#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>
#include "mxmplay.h"

void setcurshape(unsigned short);
#pragma aux setcurshape parm [cx] modify [ax] = "mov ax,0103h" "int 10h"

unsigned long t[1024];

void main(int argn, char **argv)
{
  cputs("mxm player example    (c) '95 Niklas Beisert / pascal\r\n\n");

  if (argn!=2)
  {
    cputs("argument error\r\n");
    return;
  }

  unsigned short gusport;

  if (getenv("ULTRASND"))
    gusport=strtoul(getenv("ULTRASND"), 0, 16);
  else
    gusport=0;

  char fname[_MAX_FNAME];
  char path[_MAX_PATH];
  char drive[_MAX_DRIVE];
  char dir[_MAX_DIR];
  _splitpath(argv[1], drive, dir, fname, 0);
  _makepath(path, drive, dir, fname, ".mxm");

  int f=open(path, O_RDONLY|O_BINARY);
  if (f<0)
  {
    cputs("file error\r\n");
    return;
  }
  unsigned char *mxmmem=new unsigned char [filelength(f)];
  if (!mxmmem)
  {
    cputs("malloc error\r\n");
    return;
  }
  cputs("loading file...");

  read(f, mxmmem, filelength(f));
  close(f);

  cputs("\r\nuploading samples...");
  if (!xmpInit(mxmmem, gusport, 65536))
  {
    cputs("player error\r\n");
    return;
  }

  cputs("\r\nplaying module...\r\n");
  xmpPlay();
  setcurshape(0x2000);

  while (!kbhit())
  {
    unsigned short pos=xmpGetPos();
    unsigned long tim=xmpGetTimer()/1193046;
    unsigned char sync=xmpGetSync();
    char str[20];
    str[0]=13;
    str[1]="0123456789ABCDEF"[(tim>>12)&0xF];
    str[2]="0123456789ABCDEF"[(tim>>8)&0xF];
    str[3]="0123456789ABCDEF"[(tim>>4)&0xF];
    str[4]="0123456789ABCDEF"[(tim>>0)&0xF];
    str[5]=' ';
    str[6]="0123456789ABCDEF"[(pos>>12)&0xF];
    str[7]="0123456789ABCDEF"[(pos>>8)&0xF];
    str[8]=' ';
    str[9]="0123456789ABCDEF"[(pos>>4)&0xF];
    str[10]="0123456789ABCDEF"[(pos>>0)&0xF];
    str[11]=' ';
    str[12]="0123456789ABCDEF"[(sync>>4)&0xF];
    str[13]="0123456789ABCDEF"[(sync>>0)&0xF];
    str[14]=0;
    cputs(str);
  }
  setcurshape(0xD0E);

  cputs("\r\n");

  unsigned long t0=xmpGetTimer();
  while (1)
  {
    signed long t1=(xmpGetTimer()-t0);
    if (t1>596523)
      break;
    if (t1>0)
      xmpSetVolume(64-t1/9321);
  }

  xmpStop();

  delete mxmmem;

  while (kbhit())
    getch();
}
